library SecondDll;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes;

{$R *.res}

type
  TDynArrVal = array of Integer;

function DynamicSum(DynArr: TDynArrVal): Integer; stdcall;
var
  i : integer;
  iSum : integer;
begin
  iSum := 0;

  for i := Low(DynArr) to High(DynArr) do
    iSum := iSum + DynArr[i];

  Result := iSum;
end;

function DynamicReturn(iCnt: integer): TDynArrVal; stdcall;
var
  i : integer;
  DynArr : TDynArrVal;
begin
  SetLength(DynArr, iCnt);

  for i := 0 to iCnt - 1 do
    DynArr[i] := i + 1;

  Result := DynArr;
end;


exports
  DynamicSum,
  DynamicReturn;


begin
end.
